﻿Public Class frmBinSerialLotAdd

#Region "Variables"

    Private c_oBinSerialLot As cBinSerialLot
    Private c_sScreenTitle As String = ""

#End Region

#Region "Properties"

    Public Property BinSerialLot() As cBinSerialLot
        Get
            Return c_oBinSerialLot
        End Get
        Set(ByVal value As cBinSerialLot)
            c_oBinSerialLot = value
        End Set
    End Property

    Public Property ScreenTitle() As String
        Get
            Return c_sScreenTitle
        End Get
        Set(ByVal value As String)
            c_sScreenTitle = value
        End Set
    End Property


#End Region

#Region "Constructor"

    Public Sub New()

        ' This call is required by the designer.
        InitializeComponent()

        ' Add any initialization after the InitializeComponent() call.
        c_oBinSerialLot = New cBinSerialLot
        dtEffectiveDate.Text = System.DateTime.Today
        dtExpirationDate.Text = System.DateTime.Today.AddYears(15)
        Me.ScreenTitle = Me.ScreenTitle & " " & c_sScreenTitle
    End Sub

#End Region

#Region "Events"

    Private Sub btnOK_Click(sender As System.Object, e As System.EventArgs) Handles btnOK.Click

        If (ValidFields()) Then
            CreateBinSerialLot()
            Me.DialogResult = Windows.Forms.DialogResult.OK
        Else
            Me.DialogResult = Windows.Forms.DialogResult.Cancel
        End If

    End Sub

#End Region

#Region "Public Methods"

#End Region

#Region "Private Methods"

    Private Function ValidFields() As Boolean

        Dim p_bValid As Boolean = True

        If (String.IsNullOrEmpty(txtQty.Text)) Then
            MessageBox.Show("Qty Required", "Bin Serial/Lot Add", MessageBoxButtons.OK, MessageBoxIcon.Error)
            p_bValid = False
        End If
        If (String.IsNullOrEmpty(txtBinNo.Text) AndAlso String.IsNullOrEmpty(txtSerialLotNo.Text)) Then
            MessageBox.Show("Bin No and/or Serial Lot No Required", "Bin Serial/Lot Add", MessageBoxButtons.OK, MessageBoxIcon.Error)
            p_bValid = False
        End If

        Return p_bValid

    End Function

    Private Sub CreateBinSerialLot()

        c_oBinSerialLot.BinNo = txtBinNo.Text
        c_oBinSerialLot.SerialLotNo = txtSerialLotNo.Text
        c_oBinSerialLot.MFGSerialLotNo = txtMFGSerialLotNo.Text
        c_oBinSerialLot.ToBinNo = txtToBinNo.Text
        c_oBinSerialLot.EffectiveDate = dtEffectiveDate.Value
        c_oBinSerialLot.ExpirationDate = dtExpirationDate.Value
        c_oBinSerialLot.Quantity = If(String.IsNullOrEmpty(txtQty.Text), 0, CDbl(txtQty.Text))

    End Sub

#End Region




End Class