﻿Imports System.Configuration
Imports Wisys.AllSystem
Imports Wisys.Ar

Public Class ucARCreateContact

#Region "Variables"

    Private c_oWisysConnection As Wisys.AllSystem.ConnectionInfo
    Private c_oContact As Wisys.Ar.cCicntp

#End Region

#Region "Constructor"
  
    Public Sub New(ByRef oConnectionInfo As Wisys.AllSystem.ConnectionInfo)

        ' This call is required by the designer.
        InitializeComponent()

        ' Add any initialization after the InitializeComponent() call.


        '//Instantiate the cicntp object 
        '//    Assign our Wisys ConnectionInfo object using the object's Connection method
        c_oWisysConnection = oConnectionInfo
        c_oContact = New Wisys.Ar.cCicntp()
        c_oContact.Connection(c_oWisysConnection)


    End Sub

#End Region

#Region "Private Methods"

    Private Function CreateContact(ByRef sWisysReturnMessage As String) As Integer

        Dim p_iWisysReturnValue As Integer = 0

        Try

            '//Pass the Connection
            c_oContact.Connection(c_oWisysConnection)

            '//Assign Properties 
            Dim p_oGUID As New Guid()
            p_oGUID = Guid.NewGuid()

            '//Insert Contact
            p_iWisysReturnValue = c_oContact.Insert(p_oGUID.ToString() _
                                                  , txtFirstName.Text _
                                                  , txtMiddleName.Text _
                                                  , txtLastName.Text _
                                                  , txtInitials.Text _
                                                  , txtGender.Text _
                                                  , txtSalutationCode.Text _
                                                  , txtJobTitle.Text _
                                                  , txtExt.Text _
                                                  , txtFax.Text _
                                                  , txtPhone.Text _
                                                  , txtMobile.Text _
                                                  , txtEmail.Text _
                                                  , CInt(txtAdministration.Text) _
                                                  , txtAdministration.Text _
                                                  , txtCustomerNo.Text _
                                                  , sWisysReturnMessage)
            If (p_iWisysReturnValue <> ReturnCodes.SUCCESSFUL) Then
                Return p_iWisysReturnValue
            End If

        Catch ex As Exception
            sWisysReturnMessage = ex.Message
            p_iWisysReturnValue = ReturnCodes.FAILED

        End Try

        Return p_iWisysReturnValue

    End Function

#End Region

#Region "Events"

    Private Sub btnCreateContact_Click(sender As System.Object, e As System.EventArgs) Handles btnCreateContact.Click

        Dim p_iWisysReturnValue As Integer = 0
        Dim p_sWisysReturnMessage As String = ""
        Try
            '//Start Wisys SQL Transaction
            p_iWisysReturnValue = c_oWisysConnection.OpenWisysConnection(True, p_sWisysReturnMessage)
            If (p_iWisysReturnValue <> ReturnCodes.SUCCESSFUL) Then
                MessageBox.Show(p_sWisysReturnMessage, "Open Connection")
                Return
            End If

            '//Create ES Contact
            p_iWisysReturnValue = CreateContact(p_sWisysReturnMessage)
            If (p_iWisysReturnValue <> ReturnCodes.SUCCESSFUL) Then
                MessageBox.Show(p_sWisysReturnMessage, "Create Contact")
            End If

            '//Close Wisys Connection
            Dim p_eTransactionAction As Wisys.AllSystem.TrxEnums.TransactionAction
            p_eTransactionAction = If(p_iWisysReturnValue = SUCCESSFUL, Wisys.AllSystem.TrxEnums.TransactionAction.Commit, Wisys.AllSystem.TrxEnums.TransactionAction.Rollback)
            p_iWisysReturnValue = c_oWisysConnection.CloseWisysConnection(p_eTransactionAction, p_sWisysReturnMessage)
            If (p_iWisysReturnValue <> ReturnCodes.SUCCESSFUL) Then
                MessageBox.Show(p_sWisysReturnMessage, "Close Connection")
            End If


        Catch ex As Exception
            MessageBox.Show(ex.Message, "Create Contact")

        End Try


    End Sub

#End Region

End Class
