﻿Imports Wisys.AllSystem
Imports Wisys.Oe

Public Class ucOEConvertQuoteToOrder

#Region "Variables"

    Private c_oWisysConnection As Wisys.AllSystem.ConnectionInfo
    Private c_oOrderEntryTables As Wisys.Oe.OrderEntryTables

#End Region

#Region "Constructor"

    Public Sub New(ByRef oConnectionInfo As Wisys.AllSystem.ConnectionInfo)

        ' This call is required by the designer.
        InitializeComponent()

        ' Add any initialization after the InitializeComponent() call.
        LoadCostPriceOptions()
        c_oWisysConnection = oConnectionInfo

        Dim p_sWisysReturnMessage As String = ""
        c_oOrderEntryTables = New Wisys.Oe.OrderEntryTables
        c_oOrderEntryTables.Connection(oConnectionInfo, p_sWisysReturnMessage)


    End Sub

#End Region

#Region "Properties"

#End Region

#Region "Private Methods"

    Private Sub LoadCostPriceOptions()

        Dim p_oDictionary As New Dictionary(Of String, String)()
        p_oDictionary.Add(cAppHelper.GetStringValue(cAppHelper.CostPriceOptions.Both), cAppHelper.CostPriceOptions.Both.ToString)
        p_oDictionary.Add(cAppHelper.GetStringValue(cAppHelper.CostPriceOptions.Cost), cAppHelper.CostPriceOptions.Cost.ToString)
        p_oDictionary.Add(cAppHelper.GetStringValue(cAppHelper.CostPriceOptions.Neither), cAppHelper.CostPriceOptions.Neither.ToString)
        p_oDictionary.Add(cAppHelper.GetStringValue(cAppHelper.CostPriceOptions.Price), cAppHelper.CostPriceOptions.Price.ToString)
        cbCurrentPriceCost.DataSource = New BindingSource(p_oDictionary, Nothing)
        cbCurrentPriceCost.DisplayMember = "Value"
        cbCurrentPriceCost.ValueMember = "Key"

    End Sub

    Private Function ConvertQuoteToOrder(ByRef sWisysReturnMessage As String) As Integer

        Dim p_iWisysReturnValue As Integer = 0
        Dim p_sNewOrderNo As String = ""
        Try
            '//Pass the Connection
            c_oOrderEntryTables.Connection(c_oWisysConnection, sWisysReturnMessage)

            p_iWisysReturnValue = c_oOrderEntryTables.ConvertQuoteToOrder(txtQuoteNo.Text _
                                                                        , txtCustomerNo.Text _
                                                                        , cbCurrentPriceCost.SelectedValue _
                                                                        , ckCopyItemNotes.Checked _
                                                                        , ckCopyUserDefinedFields.Checked _
                                                                        , p_sNewOrderNo _
                                                                        , sWisysReturnMessage)


            If (p_iWisysReturnValue <> ReturnCodes.SUCCESSFUL) Then
                Return p_iWisysReturnValue
            End If

            txtNewOrderNo.Text = p_sNewOrderNo

        Catch ex As Exception
            sWisysReturnMessage = ex.Message
            p_iWisysReturnValue = ReturnCodes.FAILED

        End Try

        Return p_iWisysReturnValue

    End Function

#End Region

#Region "Public Methods"

#End Region

#Region "Events"

    Private Sub btnConvertQuote_Click(sender As System.Object, e As System.EventArgs) Handles btnConvertQuote.Click

        Dim p_iWisysReturnValue As Integer = 0
        Dim p_sWisysReturnMessage As String = ""

        Try
            '//Start Wisys SQL Transaction
            p_iWisysReturnValue = c_oWisysConnection.OpenWisysConnection(True, p_sWisysReturnMessage)
            If (p_iWisysReturnValue <> ReturnCodes.SUCCESSFUL) Then
                MessageBox.Show(p_sWisysReturnMessage, "Open Connection")
                Return
            End If

            '//Convert Quote to Order
            p_iWisysReturnValue = ConvertQuoteToOrder(p_sWisysReturnMessage)
            If (p_iWisysReturnValue <> ReturnCodes.SUCCESSFUL) Then
                MessageBox.Show(p_sWisysReturnMessage, "Convert Quote to Order")
            End If

            '//Close Wisys Connection
            Dim p_eTransactionAction As Wisys.AllSystem.TrxEnums.TransactionAction
            p_eTransactionAction = If(p_iWisysReturnValue = SUCCESSFUL, Wisys.AllSystem.TrxEnums.TransactionAction.Commit, Wisys.AllSystem.TrxEnums.TransactionAction.Rollback)
            p_iWisysReturnValue = c_oWisysConnection.CloseWisysConnection(p_eTransactionAction, p_sWisysReturnMessage)
            If (p_iWisysReturnValue <> ReturnCodes.SUCCESSFUL) Then
                MessageBox.Show(p_sWisysReturnMessage, "Close Connection")
            End If

        Catch ex As Exception
            MessageBox.Show(ex.Message, "Convert Quote to Order")

        End Try

    End Sub

#End Region


End Class
